"""
    verbs configuration
"""
from classes import *

def dict(**d):
    return d

verbs = [
    dict(
        name = "Browse the internet",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Browse the internet'), "a program")],
        iconFileName  = "internet.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['program']),
    dict(
        name = "Create a new directory here",
        requirementsList = [ req(lambda x: isinstance(x, LocalFileSystemDirectory), "the parent directory")],
        iconFileName  = "folder.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = "Calculate size of directory",
        requirementsList = [ req(lambda x: isinstance(x, LocalFileSystemDirectory), "a directory")],
        iconFileName  = "size.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = "Open with Konqueror",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Open with Konqueror'), "a program"),
                             req(lambda f:isFile(f), 'a file')],
        iconFileName  = "konqueror.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Toggle scrolling buttons always visible",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Toggle scrolling buttons always visible'), "a program")],
        iconFileName  = "scroll-buttons.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['program']),
    dict(
        name = "View file size",
        requirementsList = [ req(lambda x: isFile(x), "a file")],
        iconFileName  = "size.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = "View file date",
        requirementsList = [ req(lambda x: isFile(x), "a file")],
        iconFileName  = "clock.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = "Set file permissions and owner",
        requirementsList = [ req(lambda x: isFile(x), "a file")],
        iconFileName  = "person.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = "Rename multiple files at once",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Rename multiple files at once'), "a program"),
                     req(lambda x: isFile(x), 'one or more files')],
        iconFileName  = "name.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Preview images contained in location",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Preview images contained in location'), "a program"),
                     req(lambda p:isLocation(p), 'a location with images inside')],
        iconFileName  = "glasses.png",
        isGeneric = False , #sic!
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),

    dict(
        name = "Eject disc",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.canBeEjected, 'an ejectable device')],
        iconFileName  = "cdrom.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device']),
    dict(
        name = "Erase CD-RW",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.canBurnCDs, 'a cd burner'),
                             req(lambda p:isProgramSupporting(p, 'Erase CD-RW'), 'a program')],
        iconFileName  = "cdrom.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    
    dict(
        name = 'Change resolution',
        requirementsList = [ req(lambda d:isinstance(d, device) and d.isMonitor, 'a monitor'),
                             req(lambda p:isProgramSupporting(p, 'Change resolution'), 'a program')],
        iconFileName  = "monitor.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),

    dict(
        name = "Partition disk",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.isHardDisk, 'a hard disk'),
                             req(lambda p:isProgramSupporting(p, 'Partition disk'), 'a partitioning program')],
        iconFileName  = "devices.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    dict(
        name = "Take a snapshot of your screen",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.isMonitor, 'a monitor'),
                             req(lambda p:isProgramSupporting(p, 'Take a snapshot of your screen'), 'a program')],
        iconFileName  = "gnome-screenshot.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    dict(
        name = "View free space on disk",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.containsAFileSystem, 'a device with a filesystem'),
                             req(lambda p:isProgramSupporting(p, 'View free space on disk'), 'a program')],
        iconFileName  = "devices.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    dict(
        name = "Rip CD",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.canReadCDs, 'a cd reader'),
                             req(lambda p:isProgramSupporting(p, 'Rip CD'), 'a ripping program')],
        iconFileName  = "cdrom.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    dict(
        name = "Rip DVD",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.canReadDVDs, 'a DVD reader'),
                             req(lambda p:isProgramSupporting(p, 'Rip DVD'), 'a ripping program')],
        iconFileName  = "cdrom.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    dict(
        name = "Set sound volume",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.isSoundCard, 'a sound card'),
                             req(lambda p:isProgramSupporting(p, 'Set sound volume'), 'a program')],
        iconFileName  = "volume.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    
    dict(
        name = "Shutdown",
        requirementsList = [ req(lambda d:isinstance(d, Computer), 'the computer')],
        iconFileName  = "turnoff.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['file']), # sic!
    dict(
        name = "Search directory",
        requirementsList = [ req(lambda d:isinstance(d, LocalFileSystemDirectory), 'a directory'),
                             req(lambda p:isProgramSupporting(p, 'Search directory'), 'a program')],
        iconFileName  = "stock_zoom.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file', 'program']),
    dict(
        name = "Login as different user",
        requirementsList = [ req(lambda d:isinstance(d, Computer), 'the computer')],
        iconFileName  = "generic.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['file']), # sic!
    dict(
        name = "Hybernate",
        requirementsList = [ req(lambda d:isinstance(d, Computer), 'the computer')],
        iconFileName  = "generic.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['file']), # sic!
    dict(
        name = "Change keyboard repeat speed",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.isKeyboard, 'a keyboard'),
                             req(lambda p:isProgramSupporting(p, 'Change keyboard repeat speed'), 'a program')],
        iconFileName  = "keyboard.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    dict(
        name = "Change keyboard layout",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.isKeyboard, 'a keyboard'),
                             req(lambda p:isProgramSupporting(p, 'Change keyboard layout'), 'a program')],
        iconFileName  = "keyboard.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device', 'program']),
    dict(
        name = "Configure printer",
        requirementsList = [ req(lambda d:isinstance(d, device) and d.isPrinter, 'a printer')],
        iconFileName  = "printer.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['device']),
    dict(
        name = "Copy location path to clipboard",
        requirementsList = [ req(lambda x: isLocation(x), 'a location')],
        iconFileName  = "name.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program']),
    dict(
        name = "Mail files as attachments",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Mail files as attachments'), "a program"),
                             req(lambda f:isFile(f), 'a file') ],
        isGeneric = True,
        iconFileName  = "mailto.png",
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Encrypt file",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Encrypt file'), "a program"),
                             req(lambda f:isFile(f), 'a file') ],
        isGeneric = True,
        iconFileName  = "encrypt.png",
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "View calendar",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'View calendar'), "a program"),
                             req(lambda f:isCalendarFile(f), 'a calendar file') ],
        iconFileName  = "glasses.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Check mail",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Check mail'), "a program")],
        iconFileName  = "email.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['program']),
    dict(
        name = "Compose a new email",
        requirementsList = [ req(lambda x: isProgramSupporting(x, 'Compose a new email'), "a program")],
        iconFileName  = "email.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = False,
        panelsToBeOpenedAutomatically = ['program']),
    dict(
        name = "View HTML file",
        requirementsList = [req(lambda q:isHTMLFile(q), "an HTML file"),
                    req(lambda x: isProgramSupporting(x, 'View HTML file'), "a program")],
        iconFileName  = "glasses.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "View picture",
        requirementsList = [req(lambda q:isPictureFile(q), "a picture"),
                    req(lambda x: isProgramSupporting(x, 'View picture'), "a program")],
        iconFileName  = "glasses.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Edit picture",
        requirementsList = [req(lambda q:isPictureFile(q), "a picture"),
                            req(lambda x: isProgramSupporting(x, 'Edit picture'), "a program")],
        iconFileName  = "picture.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Print picture",
        requirementsList = [req(lambda q:isPictureFile(q), "a picture"),
                            req( lambda d:isinstance(d, device) and d.isPrinter == True, 'a printer'),
                            req(lambda x: isProgramSupporting(x, 'Print picture'), "a program")],
        iconFileName  = "printer.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "View PDF",
        requirementsList = [ req(lambda q:isFileWithExtension(".pdf",q), "a PDF file"),
                             req(lambda x: isProgramSupporting(x, 'View PDF'), "a program")],
        iconFileName  = "glasses.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "View DVI file",
        requirementsList = [ req(lambda q:isFileWithExtension(".dvi",q), "a DVI file"),
                             req(lambda x: isProgramSupporting(x, 'View DVI file'), "a program")],
        iconFileName  = "glasses.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "View PS file",
        requirementsList = [ req(lambda q:isFileWithExtension(".ps",q), "a PS file"),
                             req(lambda x: isProgramSupporting(x, 'View PS file'), "a program")],
        iconFileName  = "glasses.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Add to important locations",
        requirementsList = [ req(lambda q:isLocation(q), "a location")],
        iconFileName  = "gnome-favorites.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = "Remove from important locations",
        requirementsList = [ req(lambda q:isLocation(q), "a location")],
        isGeneric = False,
        iconFileName  = "remove-from-favorites.png",
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = "Open directory with Cervisia",
        requirementsList = [ req(lambda q:isinstance(q, LocalFileSystemDirectory), 'a directory'),
                             req(lambda q:isProgramSupporting(q, 'Open directory with Cervisia'), 'a program')],
        isGeneric = False, 
        iconFileName  = "cervisia.png",
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Copy files to directory',
        requirementsList = [ req(lambda d:isinstance(d, LocalFileSystemDirectory), 'a directory'),
                     req(lambda f:isFile(f), 'a file') ],
        iconFileName = "folder-copy.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),

    dict(
        name = 'Move files to directory',
        requirementsList = [ req(lambda d:isinstance(d, LocalFileSystemDirectory), 'a directory'),
                     req(lambda f:isFile(f), 'a file')],
        isGeneric = True,
        iconFileName = "move.png",
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = 'Delete file',
        requirementsList = [ req(lambda f:isFile(f), 'a file') ],
        iconFileName = "delete.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = 'Rename file',
        requirementsList = [ req(lambda f:isFile(f), 'a file') ],
        iconFileName = "name.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file']),
    dict(
        name = 'Print PDF',
        requirementsList = [ req(lambda q:isFileWithExtension(".pdf",q), 'a PDF file'),
                             req( lambda d:isinstance(d, device) and d.isPrinter == True, 'a printer'),
                             req(lambda x: isProgramSupporting(x,  'Print PDF'), 'a program')],
        iconFileName = "printer.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'device', 'file']),
    dict(
        name = 'Print DOC',
        requirementsList = [ req(lambda q:isFileWithExtension(".doc",q), 'a .doc file'),
                             req( lambda d:isinstance(d, device) and d.isPrinter == True, 'a printer'),
                             req(lambda x: isProgramSupporting(x,  'Print DOC'), 'a program')],
        iconFileName = "printer.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'device', 'file']),
    dict(
        name = 'Print text file',
        requirementsList = [ req(lambda q:isPlainTextFile(q), 'a text file'),
                             req( lambda d:isinstance(d, device) and d.isPrinter == True, 'a printer'),
                             req(lambda x: isProgramSupporting(x,  'Print text file'), 'a program')],
        iconFileName = "printer.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'device', 'file']),
    dict(
        name = 'View files contained in RPM',
        requirementsList = [ req(lambda q:isFileWithExtension(".rpm",q), 'an RPM file'),
                             req(lambda x: isProgramSupporting(x,  'View files contained in RPM'), 'a program')],
        iconFileName = "rpm.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Extract archive',
        requirementsList = [ req(lambda q:isCompressedFile(q), 'a compressed archive'),
                             req(lambda x: isProgramSupporting(x,  'Extract archive'), 'a program')],
        iconFileName = "archive.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'View contents of archive',
        requirementsList = [ req(lambda q:isCompressedFile(q), 'a compressed archive'),
                             req(lambda x: isProgramSupporting(x,  'View contents of archive'), 'a program')],
        iconFileName = "archive.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Compress files',
        requirementsList = [ req(lambda q:isFile(q), 'a file'),
                             req(lambda x: isProgramSupporting(x,  'Compress files'), 'a program')],
        iconFileName = "archive.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Compress files separately',
        requirementsList = [ req(lambda q:isFile(q), 'a file'),
                             req(lambda x: isProgramSupporting(x,  'Compress files separately'), 'a program')],
        iconFileName = "archive.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Burn data CD',
        requirementsList = [ req(lambda q:isFile(q), 'a file'),
                             req( lambda d:isinstance(d, device) and d.canBurnCDs == True, 'a CD burner'),
                             req(lambda x: isProgramSupporting(x,  'Burn data CD'), 'a program')],
        iconFileName = "cdrom.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file', 'device']),
    dict(
        name = 'Burn audio CD',
        requirementsList = [ req(lambda q:isAudioFile(q), 'an audio file'),
                             req( lambda d:isinstance(d, device) and d.canBurnCDs == True, 'a CD burner'),
                             req(lambda x: isProgramSupporting(x,  'Burn audio CD'), 'a program')],
        iconFileName = "audio-cd.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file', 'device']),
    dict(
        name = 'Burn video CD',
        requirementsList = [ req(lambda q:isVideoFile(q), 'a video file'),
                             req( lambda d:isinstance(d, device) and d.canBurnCDs == True, 'a CD burner'),
                             req(lambda x: isProgramSupporting(x,  'Burn video CD'), 'a program')],
        iconFileName = "video-cd.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file', 'device']),
    dict(
        name = 'Burn CD from BIN and CUE files',
        requirementsList = [ req(lambda q:isinstance(q, LocalFile) and ext(q) == ".bin", 'a .bin file'),
                             req(lambda q:isinstance(q, LocalFile) and ext(q) == ".cue", 'a .cue file'),
                             req( lambda d:isinstance(d, device) and d.canBurnCDs == True, 'a CD burner'),
                             req(lambda x: isProgramSupporting(x,  'Burn CD from BIN and CUE files'), 'a program')],
        iconFileName = "cdrom.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file', 'device']),
    dict(
        name = 'Burn CD from audio and CUE files',
        requirementsList = [ req(lambda q:isAudioFile(q), 'an audio file'),
                             req(lambda q:isinstance(q, LocalFile) and ext(q) == ".cue", 'a .cue file'),
                             req( lambda d:isinstance(d, device) and d.canBurnCDs == True, 'a CD burner'),
                             req(lambda x: isProgramSupporting(x,  'Burn CD from audio and CUE files'), 'a program')],
        iconFileName = "audio-cd.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file', 'device']),
    dict(
        name = 'Burn from ISO',
        requirementsList = [ req(lambda q:isinstance(q, LocalFile) and ext(q) == '.iso', 'an ISO file'),
                             req( lambda d:isinstance(d, device) and d.canBurnCDs == True, 'a CD burner'),
                             req(lambda x: isProgramSupporting(x,  'Burn data CD'), 'a program')],
        iconFileName = "cdrom.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file', 'device']),
    dict(
        name = 'Play audio',
        requirementsList = [ req(lambda q:isAudioFile(q), 'an audio file'),
                             req( lambda x: isProgramSupporting(x, 'Play audio'), 'a program')],
        iconFileName = "audio.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Enqueue audio for playing',
        requirementsList = [ req(lambda q:isAudioFile(q), 'an audio file'),
                             req( lambda x: isProgramSupporting(x, 'Enqueue audio for playing'), 'a program')],
        iconFileName = "audio.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Enqueue video for playing',
        requirementsList = [ req(lambda q:isVideoFile(q), 'a video file'),
                             req( lambda x: isProgramSupporting(x, 'Enqueue video for playing'), 'a program')],
        iconFileName = "video.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Play movie with subtitle file',
        requirementsList = [ req(lambda q:isVideoFile(q), 'a video file'),
                             req(lambda q:isSubtitleFile(q), 'a subtitle file'),
                             req( lambda x: isProgramSupporting(x, 'Play movie with subtitle file'), 'a program')],
        iconFileName = "video.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Play movie with subtitle file and TrueType font',
        requirementsList = [ req(lambda q:isVideoFile(q), 'a video file'),
                             req(lambda q:isSubtitleFile(q), 'a subtitle file'),
                             req(lambda o: isinstance(o, LocalFile) and ext(o)=='.ttf', 'a TTF font tile'), 
                             req( lambda x: isProgramSupporting(x, 'Play movie with subtitle file and TrueType font'), 'a program')],
        iconFileName = "video.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Edit plain text file',
        requirementsList = [ req(lambda q:isinstance(q, LocalFile), 'a plain text file'),
                             req(lambda x: isProgramSupporting(x, 'Edit plain text file'), 'a program')],
        iconFileName = "text-file.png",
        isGeneric = True,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = 'Play movie',
        requirementsList = [ req(lambda q:isVideoFile(q), 'a video file'),
                             req(lambda x: isProgramSupporting(x, 'Play movie'), 'a program')],
        iconFileName = "video.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['program', 'file']),
    dict(
        name = "Open terminal in directory",
        requirementsList = [ req(lambda x: isinstance(x, LocalFileSystemDirectory), "a directory"),
                             req(lambda p:isProgramSupporting(p, 'Open terminal in directory'), 'a program')],
        iconFileName  = "gnome-terminal.png",
        isGeneric = False,
        keepLocationsVisibleWhenSelected = True,
        panelsToBeOpenedAutomatically = ['file', 'program']),
]

for n in ['Configure mouse clicking behaviour', 'Set mouse speed', 'Set mouse cursor theme']:
    verbs.append(
        dict(
            name = n,
            requirementsList = [ req(lambda d:isinstance(d, device) and d.isMouse, 'a mouse'),
                                 req(lambda p:isProgramSupporting(p, n), 'a program')],
            iconFileName  = "mouse.png",
            isGeneric = False,
            keepLocationsVisibleWhenSelected = False,
            panelsToBeOpenedAutomatically = ['device', 'program'])
    )


