# -*- coding: iso-8859-1 -*-
"""
    LogicalDesktop i18n - Package Initialization

    @copyright: 2004 by Maurizio Colucci
    @license: GNU GPL, see COPYING for details.
"""
from LogicalDesktop import config, pysupport
from meta import languages

# import the language module once and now:
if config.lang != 'en' and config.lang in meta.languages:
    text = pysupport.importName('LogicalDesktop.i18n.%s' % config.lang, 'text')
    meta = pysupport.importName('LogicalDesktop.i18n.%s' % config.lang, 'meta')
    if text is None: # loading failed
        text = {}

def _(s):
    """
        Translation function, translates given string to the
        language given by config.lang.
    """
    if config.lang == 'en':
        translation = s
    elif config.lang in languages:
        try:
            translation = text[s]
        except KeyError:
            translation = s
    else: # fall back to english
        translation = s
    return translation

